#!/bin/sh

DRIVER=rr3740a

echo "Driver Installation"
CWD=`dirname $0 2> /dev/null`
[ "$CWD" == "" ] && CWD=${0%/*}

MACHINE=`uname -m 2> /dev/null`
[ "$MACHINE" == "" ] && MACHINE=i686

KERNEL=`uname -r 2> /dev/null`
[ "$KERNEL" == "" ] && KERNEL=`awk '{ print $3 }' /proc/version 2> /dev/null`
[ "$KERNEL" == "" ] && KERNEL=`cut -d\   -f 3 /proc/version 2> /dev/null`

( echo $KERNEL | grep "386" -s -q ) && MACHINE=i386
( echo $KERNEL | grep "586" -s -q ) && MACHINE=i586
( echo $KERNEL | grep "686" -s -q ) && MACHINE=i686
( echo $KERNEL | grep "x86_64" -s -q ) && MACHINE=x86_64
( echo $KERNEL | grep "aarch64" -s -q ) && MACHINE=aarch64

cd /tmp
if [ -f $CWD/modules.cgz ]; then
  gzip -dc $CWD/modules.cgz | cpio -idum ${KERNEL}/${MACHINE}/${DRIVER}.ko > /dev/null 2>/dev/null
  if [ ! -f ${KERNEL}/${MACHINE}/${DRIVER}.ko ]; then
    echo "Error to extract driver."
    exit 1
  fi
else
  echo "No driver archive found."
  exit 1
fi

modprobe sd_mod > /dev/null 2> /dev/null
insmod ${KERNEL}/${MACHINE}/${DRIVER}.ko

echo "Driver installation step 1 completed."
